Subject: Re: bug#5080: indic text is not displayed correctly in emacs shell

From: Praveen A <[email-masked]>
Date: Fri, 4 Dec 2009 14:19:18 +0530

2009/12/4 Kenichi Handa <[email-masked]>:
> In article <[email-masked]>, Praveen A <[email-masked]> writes:
>
>> > (set-fontset-font t 'malayalam '("rachana" . "unicode-bmp"))
>> >
>> > I installed rachana font and confirmed that the above code
>> > worked.
>
>> Thanks. It works for me now. But how to make it default?
>
> Please put that in your .emacs.

Yes, I did that. I was thinking more on the lines of taking default
from system/fontconfig configuration.

>
>> I have my fontconfig preferences to prefer Meera, but emacs does not
>> respect that and takes Lohit Malayalam instead.
>
> Currently Emacs just uses the first font found to support
> Malayalam.  What is returned when you do this?
> % fc-list :lang=ml
>
pravi@savannah:~$ fc-list :lang=ml
Meera:style=Regular
FreeSerif:style=Mittel,µεσαία,Medium,Normal,Gemiddeld,navadno
Rachana:style=Regular
suruma:style=Medium
AnjaliOldLipi:style=Regular
Lohit Malayalam:style=Regular
RaghuMalayalam:style=Sans

pravi@savannah:~$ fc-match :lang=ml
Meera_04.ttf: "Meera" "Regular"
pravi@savannah:~$

I think fc-match would be a better option, but even the the preference
in fc-list is not respected in this case.

> For fontconfig, we should modify the function ftfont_list in
> (src/ftfont.c) to respect user configuration, but currently
> I don't have a time to do that.
>
>> (4a) Why is it taking Lohit Malayalam by default
>> (4b) Why is the display cluttered/overlapped with some fonts like Meera
>
>> (1a) now with your patch, emacs handles ZWJ
>> (1b) There is a problem with Lohit Malayalam, I had a discussion with
>> Lohit developer (Pravin Satpute) and he says it is an issue with
>> m17n/redering engine.
>
>> Meera and Rachana uses substitution for complex glyphs, but Lohit uses
>> some fatures of OpenType specification and which needs to be
>> implemented in rendering engine used by emacs.
>
> For a rendering problem with a specific font, please send a
> set of the following info separately for each problem.  You
> may have already sent some of them in the other mails, but,
> as I'm not a malayalam expert, I can't figure out easily
> which part is actually bad and how to reproduce the problem.
>
> (1) font file name (if possible, with the version number)

lohit_ml.ttf (ttf-malayalam-fonts 1:0.5.6)
http://ftp.de.debian.org/debian/pool/main/t/ttf-indic-fonts/ttf-indic-fonts_0.5.6.tar.gz

> (2) problematic character sequence

0x0D23 0x0D4D 0x200D

(ണ ് ‍)

> (3) image of Emacs' rendering of that sequence

emacs-lohit-zwj.png

> (4) image of the correct rendering with the same font

gedit-lohit-zwj

Thanks
Praveen
-- 
പ്രവീണ്‍ അരിമ്പ്രത്തൊടിയില്‍
<GPLv2> I know my rights; I want my phone call!
<DRM> What use is a phone call, if you are unable to speak?
(as seen on /.)
Join The DRM Elimination Crew Now!
http://fci.wikia.com/wiki/Anti-DRM-Campaign